From 204e804aa249dbbc53c6e74cd9d77d018f58a1d7 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Philip=20K=2EF=2E=20H=C3=B6lzenspies?= <holzensp@gmail.com>
Date: Thu, 3 Oct 2013 14:22:34 +0200
Subject: [PATCH] Detabbed modules that still had the -fno-warn-tabs kludge and
 stopped genprimopcode from introducing tabs that set off GHC's warning

---
 compiler/basicTypes/DataCon.lhs              | 612 ++++++++++++------------
 compiler/basicTypes/IdInfo.lhs               | 286 ++++++-----
 compiler/basicTypes/MkId.lhs                 | 162 +++----
 compiler/basicTypes/NameEnv.lhs              |  76 ++-
 compiler/basicTypes/NameSet.lhs              | 122 +++--
 compiler/basicTypes/OccName.lhs              | 418 ++++++++--------
 compiler/basicTypes/Var.lhs                  | 162 +++----
 compiler/basicTypes/VarEnv.lhs               | 270 +++++------
 compiler/basicTypes/VarSet.lhs               | 136 +++---
 compiler/cmm/CmmInfo.hs                      |  82 ++--
 compiler/coreSyn/CoreArity.lhs               | 262 +++++-----
 compiler/coreSyn/CoreLint.lhs                | 356 +++++++-------
 compiler/coreSyn/CoreSubst.lhs               | 302 ++++++------
 compiler/coreSyn/CoreSyn.lhs                 | 416 ++++++++--------
 compiler/coreSyn/CoreTidy.lhs                | 122 +++--
 compiler/coreSyn/CoreUnfold.lhs              | 532 ++++++++++-----------
 compiler/coreSyn/MkCore.lhs                  |  46 +-
 compiler/coreSyn/TrieMap.lhs                 |  66 ++-
 compiler/deSugar/DsArrows.lhs                | 418 ++++++++--------
 compiler/deSugar/DsBinds.lhs                 | 272 ++++++-----
 compiler/deSugar/DsCCall.lhs                 | 174 ++++---
 compiler/deSugar/DsUtils.lhs                 | 270 +++++------
 compiler/deSugar/MatchCon.lhs                | 110 ++---
 compiler/ghci/ByteCodeGen.lhs                |  20 +-
 compiler/ghci/ByteCodeInstr.lhs              | 156 +++---
 compiler/ghci/RtClosureInspect.hs            |  36 +-
 compiler/hsSyn/HsLit.lhs                     | 102 ++--
 compiler/hsSyn/HsUtils.lhs                   | 162 +++----
 compiler/iface/BuildTyCl.lhs                 | 270 +++++------
 compiler/iface/IfaceEnv.lhs                  | 160 +++----
 compiler/iface/IfaceSyn.lhs                  |  28 +-
 compiler/main/PprTyThing.hs                  |  74 ++-
 compiler/nativeGen/PPC/Cond.hs               |  40 +-
 compiler/nativeGen/PPC/RegInfo.hs            |  18 +-
 compiler/nativeGen/Reg.hs                    | 234 +++++----
 compiler/nativeGen/RegClass.hs               |  40 +-
 compiler/nativeGen/SPARC/CodeGen/Amode.hs    |  32 +-
 compiler/nativeGen/SPARC/CodeGen/Base.hs     |  84 ++--
 compiler/nativeGen/SPARC/CodeGen/CondCode.hs |  46 +-
 compiler/nativeGen/SPARC/CodeGen/Expand.hs   | 196 ++++----
 compiler/nativeGen/SPARC/CodeGen/Gen32.hs    | 690 +++++++++++++--------------
 compiler/nativeGen/SPARC/CodeGen/Sanity.hs   |  88 ++--
 compiler/nativeGen/SPARC/Cond.hs             |  48 +-
 compiler/nativeGen/SPARC/Imm.hs              |  72 ++-
 compiler/nativeGen/SPARC/Instr.hs            | 602 ++++++++++++-----------
 compiler/nativeGen/SPARC/Regs.hs             | 260 +++++-----
 compiler/nativeGen/SPARC/ShortcutJump.hs     |  24 +-
 compiler/nativeGen/SPARC/Stack.hs            |  46 +-
 compiler/nativeGen/Size.hs                   |  86 ++--
 compiler/nativeGen/TargetReg.hs              |  30 +-
 compiler/nativeGen/X86/RegInfo.hs            |  28 +-
 compiler/parser/Ctype.lhs                    |  46 +-
 compiler/prelude/PrelInfo.lhs                |  50 +-
 compiler/prelude/TysPrim.lhs                 | 314 ++++++------
 compiler/profiling/CostCentre.lhs            |  84 ++--
 compiler/rename/RnBinds.lhs                  | 374 +++++++--------
 compiler/simplCore/CoreMonad.lhs             | 332 +++++++------
 compiler/simplCore/FloatIn.lhs               | 226 +++++----
 compiler/simplCore/FloatOut.lhs              | 208 ++++----
 compiler/simplCore/LiberateCase.lhs          | 234 +++++----
 compiler/simplCore/SAT.lhs                   |  68 ++-
 compiler/simplCore/SetLevels.lhs             | 552 +++++++++++----------
 compiler/stranal/WorkWrap.lhs                | 184 ++++---
 compiler/stranal/WwLib.lhs                   | 392 ++++++++-------
 compiler/typecheck/FamInst.lhs               |  80 ++--
 compiler/typecheck/Inst.lhs                  | 154 +++---
 compiler/typecheck/TcArrows.lhs              | 228 +++++----
 compiler/typecheck/TcCanonical.lhs           |  34 +-
 compiler/typecheck/TcClassDcl.lhs            | 188 ++++----
 compiler/typecheck/TcDefaults.lhs            |  70 ++-
 compiler/typecheck/TcErrors.lhs              |  66 ++-
 compiler/typecheck/TcGenGenerics.lhs         |  26 +-
 compiler/typecheck/TcHsType.lhs              | 332 +++++++------
 compiler/typecheck/TcInstDcls.lhs            |  22 +-
 compiler/typecheck/TcInteract.lhs            | 118 +++--
 compiler/typecheck/TcMType.lhs               | 148 +++---
 compiler/typecheck/TcMatches.lhs             | 352 +++++++-------
 compiler/typecheck/TcPat.lhs                 | 570 +++++++++++-----------
 compiler/typecheck/TcRules.lhs               |  90 ++--
 compiler/typecheck/TcSMonad.lhs              |  65 ++-
 compiler/typecheck/TcSimplify.lhs            |  50 +-
 compiler/typecheck/TcTyDecls.lhs             |  26 +-
 compiler/typecheck/TcType.lhs                | 376 +++++++--------
 compiler/typecheck/TcUnify.lhs               | 128 +++--
 compiler/types/Class.lhs                     |  96 ++--
 compiler/types/Coercion.lhs                  | 122 +++--
 compiler/types/Kind.lhs                      |  28 +-
 compiler/types/OptCoercion.lhs               |  20 +-
 compiler/types/TypeRep.lhs                   | 188 ++++----
 compiler/types/Unify.lhs                     | 306 ++++++------
 compiler/utils/BufWrite.hs                   |  72 ++-
 compiler/utils/Digraph.lhs                   |  38 +-
 compiler/utils/GraphBase.hs                  | 122 +++--
 compiler/utils/GraphPpr.hs                   | 254 +++++-----
 utils/genprimopcode/Main.hs                  |   4 +-
 95 files changed, 8109 insertions(+), 8672 deletions(-)

diff --git a/compiler/basicTypes/DataCon.lhs b/compiler/basicTypes/DataCon.lhs
index ad56290..4cbd3ab 100644
--- a/compiler/basicTypes/DataCon.lhs
+++ b/compiler/basicTypes/DataCon.lhs
@@ -5,45 +5,39 @@
 \section[DataCon]{@DataCon@: Data Constructors}
 
 \begin{code}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module DataCon (
         -- * Main data types
-	DataCon, DataConRep(..), HsBang(..), StrictnessMark(..),
-	ConTag,
-	
-	-- ** Type construction
-	mkDataCon, fIRST_TAG,
+        DataCon, DataConRep(..), HsBang(..), StrictnessMark(..),
+        ConTag,
+        
+        -- ** Type construction
+        mkDataCon, fIRST_TAG,
         buildAlgTyCon, 
-	
-	-- ** Type deconstruction
-	dataConRepType, dataConSig, dataConFullSig,
-	dataConName, dataConIdentity, dataConTag, dataConTyCon, 
+        
+        -- ** Type deconstruction
+        dataConRepType, dataConSig, dataConFullSig,
+        dataConName, dataConIdentity, dataConTag, dataConTyCon, 
         dataConOrigTyCon, dataConUserType,
-	dataConUnivTyVars, dataConExTyVars, dataConAllTyVars, 
-	dataConEqSpec, eqSpecPreds, dataConTheta,
-	dataConStupidTheta,  
-	dataConInstArgTys, dataConOrigArgTys, dataConOrigResTy,
-	dataConInstOrigArgTys, dataConRepArgTys, 
-	dataConFieldLabels, dataConFieldType,
-	dataConStrictMarks, 
-	dataConSourceArity, dataConRepArity, dataConRepRepArity,
-	dataConIsInfix,
-	dataConWorkId, dataConWrapId, dataConWrapId_maybe, dataConImplicitIds,
-	dataConRepStrictness, dataConRepBangs, dataConBoxer,
-
-	splitDataProductType_maybe,
+        dataConUnivTyVars, dataConExTyVars, dataConAllTyVars, 
+        dataConEqSpec, eqSpecPreds, dataConTheta,
+        dataConStupidTheta,  
+        dataConInstArgTys, dataConOrigArgTys, dataConOrigResTy,
+        dataConInstOrigArgTys, dataConRepArgTys, 
+        dataConFieldLabels, dataConFieldType,
+        dataConStrictMarks, 
+        dataConSourceArity, dataConRepArity, dataConRepRepArity,
+        dataConIsInfix,
+        dataConWorkId, dataConWrapId, dataConWrapId_maybe, dataConImplicitIds,
+        dataConRepStrictness, dataConRepBangs, dataConBoxer,
+
+        splitDataProductType_maybe,
 
         tyConsOfTyCon,
 
-	-- ** Predicates on DataCons
-	isNullarySrcDataCon, isNullaryRepDataCon, isTupleDataCon, isUnboxedTupleCon,
-	isVanillaDataCon, classDataCon, dataConCannotMatch,
+        -- ** Predicates on DataCons
+        isNullarySrcDataCon, isNullaryRepDataCon, isTupleDataCon, isUnboxedTupleCon,
+        isVanillaDataCon, classDataCon, dataConCannotMatch,
         isBanged, isMarkedStrict, eqHsBang,
 
         -- ** Promotion related functions
@@ -86,30 +80,30 @@ Data constructor representation
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Consider the following Haskell data type declaration
 
-	data T = T !Int ![Int]
+        data T = T !Int ![Int]
 
 Using the strictness annotations, GHC will represent this as
 
-	data T = T Int# [Int]
+        data T = T Int# [Int]
 
 That is, the Int has been unboxed.  Furthermore, the Haskell source construction
 
-	T e1 e2
+        T e1 e2
 
 is translated to
 
-	case e1 of { I# x -> 
-	case e2 of { r ->
-	T x r }}
+        case e1 of { I# x -> 
+        case e2 of { r ->
+        T x r }}
 
 That is, the first argument is unboxed, and the second is evaluated.  Finally,
 pattern matching is translated too:
 
-	case e of { T a b -> ... }
+        case e of { T a b -> ... }
 
 becomes
 
-	case e of { T a' b -> let a = I# a' in ... }
+        case e of { T a' b -> let a = I# a' in ... }
 
 To keep ourselves sane, we name the different versions of the data constructor
 differently, as follows.
@@ -119,11 +113,11 @@ Note [Data Constructor Naming]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Each data constructor C has two, and possibly up to four, Names associated with it:
 
-		   OccName   Name space	  Name of   Notes
+                   OccName   Name space   Name of   Notes
  ---------------------------------------------------------------------------
- The "data con itself" 	 C     DataName	  DataCon   In dom( GlobalRdrEnv )
- The "worker data con"	 C     VarName	  Id        The worker
- The "wrapper data con"	 $WC   VarName	  Id        The wrapper
+ The "data con itself"   C     DataName   DataCon   In dom( GlobalRdrEnv )
+ The "worker data con"   C     VarName    Id        The worker
+ The "wrapper data con"  $WC   VarName    Id        The wrapper
  The "newtype coercion"  :CoT  TcClsName  TyCon
  
 EVERY data constructor (incl for newtypes) has the former two (the
@@ -147,11 +141,11 @@ The "worker Id", is the actual data constructor.
 
 * For a *newtype*, the worker has a compulsory unfolding which 
   does a cast, e.g.
-	newtype T = MkT Int
-	The worker for MkT has unfolding
-		\\(x:Int). x `cast` sym CoT
+        newtype T = MkT Int
+        The worker for MkT has unfolding
+                \\(x:Int). x `cast` sym CoT
   Here CoT is the type constructor, witnessing the FC axiom
-	axiom CoT : T = Int
+        axiom CoT : T = Int
 
 The "wrapper Id", \$WC, goes as follows
 
@@ -162,235 +156,235 @@ The "wrapper Id", \$WC, goes as follows
 
 * The wrapper Id isn't generated for a data type if there is
   nothing for the wrapper to do.  That is, if its defn would be
-	\$wC = C
+        \$wC = C
 
 Note [The need for a wrapper]
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Why might the wrapper have anything to do?  Two reasons:
 
 * Unboxing strict fields (with -funbox-strict-fields)
-	data T = MkT !(Int,Int)
-	\$wMkT :: (Int,Int) -> T
-	\$wMkT (x,y) = MkT x y
+        data T = MkT !(Int,Int)
+        \$wMkT :: (Int,Int) -> T
+        \$wMkT (x,y) = MkT x y
   Notice that the worker has two fields where the wapper has 
   just one.  That is, the worker has type
-		MkT :: Int -> Int -> T
+                MkT :: Int -> Int -> T
 
 * Equality constraints for GADTs
-	data T a where { MkT :: a -> T [a] }
+        data T a where { MkT :: a -> T [a] }
 
   The worker gets a type with explicit equality
   constraints, thus:
-	MkT :: forall a b. (a=[b]) => b -> T a
+        MkT :: forall a b. (a=[b]) => b -> T a
 
   The wrapper has the programmer-specified type:
-	\$wMkT :: a -> T [a]
-	\$wMkT a x = MkT [a] a [a] x
+        \$wMkT :: a -> T [a]
+        \$wMkT a x = MkT [a] a [a] x
   The third argument is a coerion
-	[a] :: [a]~[a]
+        [a] :: [a]~[a]
 
 INVARIANT: the dictionary constructor for a class
-	   never has a wrapper.
+           never has a wrapper.
 
 
 A note about the stupid context
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 Data types can have a context:
-	
-	data (Eq a, Ord b) => T a b = T1 a b | T2 a
+        
+        data (Eq a, Ord b) => T a b = T1 a b | T2 a
 
 and that makes the constructors have a context too
 (notice that T2's context is "thinned"):
 
-	T1 :: (Eq a, Ord b) => a -> b -> T a b
-	T2 :: (Eq a) => a -> T a b
+        T1 :: (Eq a, Ord b) => a -> b -> T a b
+        T2 :: (Eq a) => a -> T a b
 
 Furthermore, this context pops up when pattern matching
 (though GHC hasn't implemented this, but it is in H98, and
 I've fixed GHC so that it now does):
 
-	f (T2 x) = x
+        f (T2 x) = x
 gets inferred type
-	f :: Eq a => T a b -> a
+        f :: Eq a => T a b -> a
 
 I say the context is "stupid" because the dictionaries passed
 are immediately discarded -- they do nothing and have no benefit.
 It's a flaw in the language.
 
-	Up to now [March 2002] I have put this stupid context into the
-	type of the "wrapper" constructors functions, T1 and T2, but
-	that turned out to be jolly inconvenient for generics, and
-	record update, and other functions that build values of type T
-	(because they don't have suitable dictionaries available).
+        Up to now [March 2002] I have put this stupid context into the
+        type of the "wrapper" constructors functions, T1 and T2, but
+        that turned out to be jolly inconvenient for generics, and
+        record update, and other functions that build values of type T
+        (because they don't have suitable dictionaries available).
 
-	So now I've taken the stupid context out.  I simply deal with
-	it separately in the type checker on occurrences of a
-	constructor, either in an expression or in a pattern.
+        So now I've taken the stupid context out.  I simply deal with
+        it separately in the type checker on occurrences of a
+        constructor, either in an expression or in a pattern.
 
-	[May 2003: actually I think this decision could evasily be
-	reversed now, and probably should be.  Generics could be
-	disabled for types with a stupid context; record updates now
-	(H98) needs the context too; etc.  It's an unforced change, so
-	I'm leaving it for now --- but it does seem odd that the
-	wrapper doesn't include the stupid context.]
+        [May 2003: actually I think this decision could evasily be
+        reversed now, and probably should be.  Generics could be
+        disabled for types with a stupid context; record updates now
+        (H98) needs the context too; etc.  It's an unforced change, so
+        I'm leaving it for now --- but it does seem odd that the
+        wrapper doesn't include the stupid context.]
 
 [July 04] With the advent of generalised data types, it's less obvious
 what the "stupid context" is.  Consider
-	C :: forall a. Ord a => a -> a -> T (Foo a)
+        C :: forall a. Ord a => a -> a -> T (Foo a)
 Does the C constructor in Core contain the Ord dictionary?  Yes, it must:
 
-	f :: T b -> Ordering
-	f = /\b. \x:T b. 
-	    case x of
-		C a (d:Ord a) (p:a) (q:a) -> compare d p q
+        f :: T b -> Ordering
+        f = /\b. \x:T b. 
+            case x of
+                C a (d:Ord a) (p:a) (q:a) -> compare d p q
 
 Note that (Foo a) might not be an instance of Ord.
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Data constructors}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 -- | A data constructor
 data DataCon
   = MkData {
-	dcName    :: Name,	-- This is the name of the *source data con*
-				-- (see "Note [Data Constructor Naming]" above)
-	dcUnique :: Unique, 	-- Cached from Name
-	dcTag    :: ConTag,     -- ^ Tag, used for ordering 'DataCon's
-
-	-- Running example:
-	--
-	-- 	*** As declared by the user
-	--  data T a where
-	--    MkT :: forall x y. (x~y,Ord x) => x -> y -> T (x,y)
-
-	-- 	*** As represented internally
-	--  data T a where
-	--    MkT :: forall a. forall x y. (a~(x,y),x~y,Ord x) => x -> y -> T a
-	-- 
-	-- The next six fields express the type of the constructor, in pieces
-	-- e.g.
-	--
-	--	dcUnivTyVars  = [a]
-	--	dcExTyVars    = [x,y]
-	--	dcEqSpec      = [a~(x,y)]
-	--	dcOtherTheta  = [x~y, Ord x]	
-	--	dcOrigArgTys  = [x,y]
-	--	dcRepTyCon       = T
-
-	dcVanilla :: Bool,	-- True <=> This is a vanilla Haskell 98 data constructor
-				--	    Its type is of form
-				--	        forall a1..an . t1 -> ... tm -> T a1..an
-				-- 	    No existentials, no coercions, nothing.
-				-- That is: dcExTyVars = dcEqSpec = dcOtherTheta = []
-		-- NB 1: newtypes always have a vanilla data con
-		-- NB 2: a vanilla constructor can still be declared in GADT-style 
-		--	 syntax, provided its type looks like the above.
-		--       The declaration format is held in the TyCon (algTcGadtSyntax)
-
-	dcUnivTyVars :: [TyVar],	-- Universally-quantified type vars [a,b,c]
-					-- INVARIANT: length matches arity of the dcRepTyCon
-					---           result type of (rep) data con is exactly (T a b c)
-
-	dcExTyVars   :: [TyVar],	-- Existentially-quantified type vars 
-		-- In general, the dcUnivTyVars are NOT NECESSARILY THE SAME AS THE TYVARS
-		-- FOR THE PARENT TyCon. With GADTs the data con might not even have 
-		-- the same number of type variables.
-		-- [This is a change (Oct05): previously, vanilla datacons guaranteed to
-		--  have the same type variables as their parent TyCon, but that seems ugly.]
-
-	-- INVARIANT: the UnivTyVars and ExTyVars all have distinct OccNames
-	-- Reason: less confusing, and easier to generate IfaceSyn
-
-	dcEqSpec :: [(TyVar,Type)],	-- Equalities derived from the result type, 
-					-- _as written by the programmer_
-		-- This field allows us to move conveniently between the two ways
-		-- of representing a GADT constructor's type:
-		--	MkT :: forall a b. (a ~ [b]) => b -> T a
-		--	MkT :: forall b. b -> T [b]
-		-- Each equality is of the form (a ~ ty), where 'a' is one of 
-		-- the universally quantified type variables
-					
-		-- The next two fields give the type context of the data constructor
-		-- 	(aside from the GADT constraints, 
-		--	 which are given by the dcExpSpec)
-		-- In GADT form, this is *exactly* what the programmer writes, even if
-		-- the context constrains only universally quantified variables
-		--	MkT :: forall a b. (a ~ b, Ord b) => a -> T a b
-	dcOtherTheta :: ThetaType,  -- The other constraints in the data con's type
-		                    -- other than those in the dcEqSpec
-
-	dcStupidTheta :: ThetaType,	-- The context of the data type declaration 
-					--	data Eq a => T a = ...
-					-- or, rather, a "thinned" version thereof
-		-- "Thinned", because the Report says
-		-- to eliminate any constraints that don't mention
-		-- tyvars free in the arg types for this constructor
-		--
-		-- INVARIANT: the free tyvars of dcStupidTheta are a subset of dcUnivTyVars
-		-- Reason: dcStupidTeta is gotten by thinning the stupid theta from the tycon
-		-- 
-		-- "Stupid", because the dictionaries aren't used for anything.  
-		-- Indeed, [as of March 02] they are no longer in the type of 
-		-- the wrapper Id, because that makes it harder to use the wrap-id 
-		-- to rebuild values after record selection or in generics.
-
-	dcOrigArgTys :: [Type],		-- Original argument types
-					-- (before unboxing and flattening of strict fields)
-	dcOrigResTy :: Type,		-- Original result type, as seen by the user
-		-- NB: for a data instance, the original user result type may 
-		-- differ from the DataCon's representation TyCon.  Example
-		--	data instance T [a] where MkT :: a -> T [a]
-		-- The OrigResTy is T [a], but the dcRepTyCon might be :T123
-
-	-- Now the strictness annotations and field labels of the constructor
+        dcName    :: Name,      -- This is the name of the *source data con*
+                                -- (see "Note [Data Constructor Naming]" above)
+        dcUnique :: Unique,     -- Cached from Name
+        dcTag    :: ConTag,     -- ^ Tag, used for ordering 'DataCon's
+
+        -- Running example:
+        --
+        --      *** As declared by the user
+        --  data T a where
+        --    MkT :: forall x y. (x~y,Ord x) => x -> y -> T (x,y)
+
+        --      *** As represented internally
+        --  data T a where
+        --    MkT :: forall a. forall x y. (a~(x,y),x~y,Ord x) => x -> y -> T a
+        -- 
+        -- The next six fields express the type of the constructor, in pieces
+        -- e.g.
+        --
+        --      dcUnivTyVars  = [a]
+        --      dcExTyVars    = [x,y]
+        --      dcEqSpec      = [a~(x,y)]
+        --      dcOtherTheta  = [x~y, Ord x]    
+        --      dcOrigArgTys  = [x,y]
+        --      dcRepTyCon       = T
+
+        dcVanilla :: Bool,      -- True <=> This is a vanilla Haskell 98 data constructor
+                                --          Its type is of form
+                                --              forall a1..an . t1 -> ... tm -> T a1..an
+                                --          No existentials, no coercions, nothing.
+                                -- That is: dcExTyVars = dcEqSpec = dcOtherTheta = []
+                -- NB 1: newtypes always have a vanilla data con
+                -- NB 2: a vanilla constructor can still be declared in GADT-style 
+                --       syntax, provided its type looks like the above.
+                --       The declaration format is held in the TyCon (algTcGadtSyntax)
+
+        dcUnivTyVars :: [TyVar],        -- Universally-quantified type vars [a,b,c]
+                                        -- INVARIANT: length matches arity of the dcRepTyCon
+                                        ---           result type of (rep) data con is exactly (T a b c)
+
+        dcExTyVars   :: [TyVar],        -- Existentially-quantified type vars 
+                -- In general, the dcUnivTyVars are NOT NECESSARILY THE SAME AS THE TYVARS
+                -- FOR THE PARENT TyCon. With GADTs the data con might not even have 
+                -- the same number of type variables.
+                -- [This is a change (Oct05): previously, vanilla datacons guaranteed to
+                --  have the same type variables as their parent TyCon, but that seems ugly.]
+
+        -- INVARIANT: the UnivTyVars and ExTyVars all have distinct OccNames
+        -- Reason: less confusing, and easier to generate IfaceSyn
+
+        dcEqSpec :: [(TyVar,Type)],     -- Equalities derived from the result type, 
+                                        -- _as written by the programmer_
+                -- This field allows us to move conveniently between the two ways
+                -- of representing a GADT constructor's type:
+                --      MkT :: forall a b. (a ~ [b]) => b -> T a
+                --      MkT :: forall b. b -> T [b]
+                -- Each equality is of the form (a ~ ty), where 'a' is one of 
+                -- the universally quantified type variables
+                                        
+                -- The next two fields give the type context of the data constructor
+                --      (aside from the GADT constraints, 
+                --       which are given by the dcExpSpec)
+                -- In GADT form, this is *exactly* what the programmer writes, even if
+                -- the context constrains only universally quantified variables
+                --      MkT :: forall a b. (a ~ b, Ord b) => a -> T a b
+        dcOtherTheta :: ThetaType,  -- The other constraints in the data con's type
+                                    -- other than those in the dcEqSpec
+
+        dcStupidTheta :: ThetaType,     -- The context of the data type declaration 
+                                        --      data Eq a => T a = ...
+                                        -- or, rather, a "thinned" version thereof
+                -- "Thinned", because the Report says
+                -- to eliminate any constraints that don't mention
+                -- tyvars free in the arg types for this constructor
+                --
+                -- INVARIANT: the free tyvars of dcStupidTheta are a subset of dcUnivTyVars
+                -- Reason: dcStupidTeta is gotten by thinning the stupid theta from the tycon
+                -- 
+                -- "Stupid", because the dictionaries aren't used for anything.  
+                -- Indeed, [as of March 02] they are no longer in the type of 
+                -- the wrapper Id, because that makes it harder to use the wrap-id 
+                -- to rebuild values after record selection or in generics.
+
+        dcOrigArgTys :: [Type],         -- Original argument types
+                                        -- (before unboxing and flattening of strict fields)
+        dcOrigResTy :: Type,            -- Original result type, as seen by the user
+                -- NB: for a data instance, the original user result type may 
+                -- differ from the DataCon's representation TyCon.  Example
+                --      data instance T [a] where MkT :: a -> T [a]
+                -- The OrigResTy is T [a], but the dcRepTyCon might be :T123
+
+        -- Now the strictness annotations and field labels of the constructor
         -- See Note [Bangs on data constructor arguments]
-	dcArgBangs :: [HsBang],
-		-- Strictness annotations as decided by the compiler.  
-		-- Matches 1-1 with dcOrigArgTys
-		-- Hence length = dataConSourceArity dataCon
-
-	dcFields  :: [FieldLabel],
-		-- Field labels for this constructor, in the
-		-- same order as the dcOrigArgTys; 
-		-- length = 0 (if not a record) or dataConSourceArity.
-
-	-- The curried worker function that corresponds to the constructor:
-	-- It doesn't have an unfolding; the code generator saturates these Ids
-	-- and allocates a real constructor when it finds one.
-	dcWorkId :: Id,
-
-	-- Constructor representation
+        dcArgBangs :: [HsBang],
+                -- Strictness annotations as decided by the compiler.  
+                -- Matches 1-1 with dcOrigArgTys
+                -- Hence length = dataConSourceArity dataCon
+
+        dcFields  :: [FieldLabel],
+                -- Field labels for this constructor, in the
+                -- same order as the dcOrigArgTys; 
+                -- length = 0 (if not a record) or dataConSourceArity.
+
+        -- The curried worker function that corresponds to the constructor:
+        -- It doesn't have an unfolding; the code generator saturates these Ids
+        -- and allocates a real constructor when it finds one.
+        dcWorkId :: Id,
+
+        -- Constructor representation
         dcRep      :: DataConRep,
 
         -- Cached
         dcRepArity    :: Arity,  -- == length dataConRepArgTys
         dcSourceArity :: Arity,  -- == length dcOrigArgTys
 
-	-- Result type of constructor is T t1..tn
-	dcRepTyCon  :: TyCon,		-- Result tycon, T
+        -- Result type of constructor is T t1..tn
+        dcRepTyCon  :: TyCon,           -- Result tycon, T
 
-	dcRepType   :: Type,	-- Type of the constructor
-				-- 	forall a x y. (a~(x,y), x~y, Ord x) =>
+        dcRepType   :: Type,    -- Type of the constructor
+                                --      forall a x y. (a~(x,y), x~y, Ord x) =>
                                 --        x -> y -> T a
-				-- (this is *not* of the constructor wrapper Id:
-				--  see Note [Data con representation] below)
-	-- Notice that the existential type parameters come *second*.  
-	-- Reason: in a case expression we may find:
-	--	case (e :: T t) of
+                                -- (this is *not* of the constructor wrapper Id:
+                                --  see Note [Data con representation] below)
+        -- Notice that the existential type parameters come *second*.  
+        -- Reason: in a case expression we may find:
+        --      case (e :: T t) of
         --        MkT x y co1 co2 (d:Ord x) (v:r) (w:F s) -> ...
-	-- It's convenient to apply the rep-type of MkT to 't', to get
-	--	forall x y. (t~(x,y), x~y, Ord x) => x -> y -> T t
-	-- and use that to check the pattern.  Mind you, this is really only
-	-- used in CoreLint.
+        -- It's convenient to apply the rep-type of MkT to 't', to get
+        --      forall x y. (t~(x,y), x~y, Ord x) => x -> y -> T t
+        -- and use that to check the pattern.  Mind you, this is really only
+        -- used in CoreLint.
 
 
-	dcInfix :: Bool,	-- True <=> declared infix
-				-- Used for Template Haskell and 'deriving' only
-				-- The actual fixity is stored elsewhere
+        dcInfix :: Bool,        -- True <=> declared infix
+                                -- Used for Template Haskell and 'deriving' only
+                                -- The actual fixity is stored elsewhere
 
         dcPromoted :: Maybe TyCon    -- The promoted TyCon if this DataCon is promotable
                                      -- See Note [Promoted data constructors] in TyCon
@@ -410,7 +404,7 @@ data DataConRep
                                  -- and *including* all evidence args
 
         , dcr_stricts :: [StrictnessMark]  -- 1-1 with dcr_arg_tys
-		-- See also Note [Data-con worker strictness] in MkId.lhs
+                -- See also Note [Data-con worker strictness] in MkId.lhs
 
         , dcr_bangs :: [HsBang]  -- The actual decisions made (including failures)
                                  -- 1-1 with orig_arg_tys
@@ -435,7 +429,7 @@ data DataConRep
 -- but it also ensures that the wrapper is replaced
 -- by the worker (because it *is* the worker)
 -- even when there are no args. E.g. in
--- 		f (:) x
+--              f (:) x
 -- the (:) *is* the worker.
 -- This is really important in rule matching,
 -- (We could match on the wrappers,
@@ -452,7 +446,7 @@ data HsBang
                           -- Nothing      no pragma
        Bool               -- True <=> '!' specified
 
-  | HsNoBang	          -- Lazy field
+  | HsNoBang              -- Lazy field
                           -- HsUserBang Nothing False means the same as HsNoBang
 
   | HsUnpack              -- Definite commitment: this field is strict and unboxed
@@ -464,7 +458,7 @@ data HsBang
 -------------------------
 -- StrictnessMark is internal only, used to indicate strictness 
 -- of the DataCon *worker* fields
-data StrictnessMark = MarkedStrict | NotMarkedStrict	
+data StrictnessMark = MarkedStrict | NotMarkedStrict    
 \end{code}
 
 Note [Data con representation]
@@ -472,17 +466,17 @@ Note [Data con representation]
 The dcRepType field contains the type of the representation of a contructor
 This may differ from the type of the contructor *Id* (built
 by MkId.mkDataConId) for two reasons:
-	a) the constructor Id may be overloaded, but the dictionary isn't stored
-	   e.g.    data Eq a => T a = MkT a a
+        a) the constructor Id may be overloaded, but the dictionary isn't stored
+           e.g.    data Eq a => T a = MkT a a
 
-	b) the constructor may store an unboxed version of a strict field.
+        b) the constructor may store an unboxed version of a strict field.
 
 Here's an example illustrating both:
-	data Ord a => T a = MkT Int! a
+        data Ord a => T a = MkT Int! a
 Here
-	T :: Ord a => Int -> a -> T a
+        T :: Ord a => Int -> a -> T a
 but the rep type is
-	Trep :: Int# -> a -> T a
+        Trep :: Int# -> a -> T a
 Actually, the unboxed part isn't implemented yet!
 
 Note [Bangs on data constructor arguments]
@@ -508,9 +502,9 @@ dcr_bangs field; we don't know what the user originally said.
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Instances}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -520,9 +514,9 @@ instance Eq DataCon where
 
 instance Ord DataCon where
     a <= b = getUnique a <= getUnique b
-    a <	 b = getUnique a <  getUnique b
+    a <  b = getUnique a <  getUnique b
     a >= b = getUnique a >= getUnique b
-    a >	 b = getUnique a > getUnique b
+    a >  b = getUnique a > getUnique b
     compare a b = getUnique a `compare` getUnique b
 
 instance Uniquable DataCon where
@@ -581,42 +575,42 @@ isMarkedStrict _               = True   -- All others are strict
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Construction}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 -- | Build a new data constructor
 mkDataCon :: Name 
-	  -> Bool	        -- ^ Is the constructor declared infix?
-	  -> [HsBang]           -- ^ Strictness annotations written in the source file
-	  -> [FieldLabel]       -- ^ Field labels for the constructor, if it is a record, 
-				--   otherwise empty
-	  -> [TyVar]            -- ^ Universally quantified type variables
-	  -> [TyVar]            -- ^ Existentially quantified type variables
-	  -> [(TyVar,Type)]     -- ^ GADT equalities
-	  -> ThetaType          -- ^ Theta-type occuring before the arguments proper
-	  -> [Type]             -- ^ Original argument types
-	  -> Type		-- ^ Original result type
-	  -> TyCon              -- ^ Representation type constructor
-	  -> ThetaType          -- ^ The "stupid theta", context of the data declaration 
-				--   e.g. @data Eq a => T a ...@
+          -> Bool               -- ^ Is the constructor declared infix?
+          -> [HsBang]           -- ^ Strictness annotations written in the source file
+          -> [FieldLabel]       -- ^ Field labels for the constructor, if it is a record, 
+                                --   otherwise empty
+          -> [TyVar]            -- ^ Universally quantified type variables
+          -> [TyVar]            -- ^ Existentially quantified type variables
+          -> [(TyVar,Type)]     -- ^ GADT equalities
+          -> ThetaType          -- ^ Theta-type occuring before the arguments proper
+          -> [Type]             -- ^ Original argument types
+          -> Type               -- ^ Original result type
+          -> TyCon              -- ^ Representation type constructor
+          -> ThetaType          -- ^ The "stupid theta", context of the data declaration 
+                                --   e.g. @data Eq a => T a ...@
           -> Id                 -- ^ Worker Id
-	  -> DataConRep         -- ^ Representation
-	  -> DataCon
+          -> DataConRep         -- ^ Representation
+          -> DataCon
   -- Can get the tag from the TyCon
 
 mkDataCon name declared_infix
-	  arg_stricts	-- Must match orig_arg_tys 1-1
-	  fields
-	  univ_tvs ex_tvs 
-	  eq_spec theta
-	  orig_arg_tys orig_res_ty rep_tycon
-	  stupid_theta work_id rep
+          arg_stricts   -- Must match orig_arg_tys 1-1
+          fields
+          univ_tvs ex_tvs 
+          eq_spec theta
+          orig_arg_tys orig_res_ty rep_tycon
+          stupid_theta work_id rep
 -- Warning: mkDataCon is not a good place to check invariants. 
 -- If the programmer writes the wrong result type in the decl, thus:
---	data T a where { MkT :: S }
+--      data T a where { MkT :: S }
 -- then it's possible that the univ_tvs may hit an assertion failure
 -- if you pull on univ_tvs.  This case is checked by checkValidDataCon,
 -- so the error is detected properly... it's just that asaertions here
